"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_universal_interface_1 = require("react-universal-interface");
var Tween_1 = require("../Tween");
var util_1 = require("../util");
exports.Interpolation = function (props) {
    return util_1.h(Tween_1.Tween, props, function (_a) {
        var value = _a.value;
        var map = props.map;
        var keys = Object.keys(map);
        var interpolated = {};
        for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            var _b = map[key], start = _b[0], end = _b[1];
            var diff = end - start;
            interpolated[key] = start + (diff * value);
        }
        return react_universal_interface_1.render(props, interpolated);
    });
};
exports.withInterpolation = react_universal_interface_1.createEnhancer(exports.Interpolation, 'interpolation');
//# sourceMappingURL=index.js.map