"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Value_1 = require("../Value");
var renderProp_1 = tslib_1.__importDefault(require("../util/renderProp"));
exports.List = function (props) {
    return Value_1.Value({
        init: Array.isArray(props.init) ? props.init : [],
        render: function (state) {
            var value = state.value, set = state.set;
            return renderProp_1.default(props, Object.assign(state, {
                push: function (entry) { return set(value.concat([entry])); },
                filter: function (fn) { return set(value.filter(fn)); },
                sort: function (fn) { return set(value.slice().sort(fn)); }
            }));
        }
    });
};
exports.withList = Value_1.faccToHocInit(exports.List, 'list');
//# sourceMappingURL=index.js.map