"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var util_1 = require("../util");
var OutsideClick = (function (_super) {
    tslib_1.__extends(OutsideClick, _super);
    function OutsideClick() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = function (originalRef) { return function (el) {
            var clickRoots = _this.props.clickRoots;
            _this.roots = clickRoots
                ? clickRoots()
                : [el];
            (originalRef || util_1.noop)(el);
        }; };
        _this.onClickOutside = function (event) {
            if (!_this.roots.length) {
                return;
            }
            var inside = _this.roots.some(function (root) { return (root.contains(event.target)); });
            if (!inside) {
                (_this.props.onClick || util_1.noop)(event);
            }
        };
        return _this;
    }
    OutsideClick.prototype.componentDidMount = function () {
        util_1.on(document, this.props.event, this.onClickOutside);
    };
    OutsideClick.prototype.componentWillUnmount = function () {
        util_1.off(document, this.props.event, this.onClickOutside);
    };
    OutsideClick.prototype.render = function () {
        var children = this.props.children;
        var element = React.Children.only(children);
        if (!element) {
            return null;
        }
        return React.cloneElement(element, tslib_1.__assign({}, element.props, { ref: this.ref(element.ref) }));
    };
    OutsideClick.defaultProps = {
        event: 'mousedown'
    };
    return OutsideClick;
}(React.Component));
exports.OutsideClick = OutsideClick;
//# sourceMappingURL=index.js.map