"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var util_1 = require("../util");
var Prompt = (function (_super) {
    tslib_1.__extends(Prompt, _super);
    function Prompt() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Prompt.prototype.componentDidMount = function () {
        if (!(typeof this.props.children === 'function')) {
            this.prompt();
        }
    };
    Prompt.prototype.componentDidUpdate = function () {
        if (!(typeof this.props.children === 'function')) {
            this.prompt();
        }
    };
    Prompt.prototype.prompt = function () {
        var _a = this.props, show = _a.show, message = _a.message, def = _a.default, onResult = _a.onResult;
        if (show) {
            var result = prompt(message, def);
            (onResult || util_1.noop)(result);
            return result;
        }
        return undefined;
    };
    Prompt.prototype.render = function () {
        var _a = this.props, children = _a.children, def = _a.default;
        if (typeof children === 'function') {
            if (util_1.isClient) {
                var result = this.prompt();
                return children(result);
            }
            else {
                return children(def);
            }
        }
        else {
            return children || null;
        }
    };
    return Prompt;
}(React.PureComponent));
exports.Prompt = Prompt;
//# sourceMappingURL=index.js.map