"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var precision = 1e-3;
var maxIterations = 5;
var createBezierEasing = function (x1, y1, x2, y2) {
    var Cx = 3 * x1;
    var Bx = 3 * (x2 - x1) - Cx;
    var Bx2 = Bx * 2;
    var Ax = 1 - Cx - Bx;
    var Ax3 = Ax * 3;
    var Cy = 3 * y1;
    var By = 3 * (y2 - y1) - Cy;
    var Ay = 1 - Cy - By;
    return function (t) {
        var x = t;
        var i = 0;
        var z;
        for (; i < maxIterations; i++) {
            z = x * (Cx + x * (Bx + x * Ax)) - t;
            if (Math.abs(z) < precision) {
                break;
            }
            x = x - z / (Cx + x * (Bx2 + x * Ax3));
        }
        return x * (Cy + x * (By + x * Ay));
    };
};
exports.default = createBezierEasing;
//# sourceMappingURL=createBezierEasing.js.map