"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_universal_interface_1 = require("react-universal-interface");
var Render_1 = require("../Render");
var util_1 = require("../util");
var easing_1 = require("./easing");
exports.Tween = function (props) {
    var _a = props.easing, fn = _a === void 0 ? 'linear' : _a;
    if (typeof props.easing === 'string') {
        fn = easing_1.easing[fn];
    }
    if (process.env.NODE_ENV !== 'production') {
        if (typeof fn !== 'function') {
            console.error('<Tween> expected "easing" property to be a valid easing function or a 4-tuple array or numbers ' +
                'specifying a Cubic Bezier curve, or a string specifying one of the built-int easing functions: ' +
                '"' + Object.keys(easing_1.easing).join('", "') + '".');
            console.trace();
            return null;
        }
    }
    return util_1.h(props.Render, props, function (_a) {
        var value = _a.value;
        return react_universal_interface_1.render(props, { value: fn(value) });
    });
};
exports.Tween.defaultProps = {
    easing: 'linear',
    Render: Render_1.Render
};
exports.withTween = react_universal_interface_1.createEnhancer(exports.Tween, 'tween');
//# sourceMappingURL=index.js.map