"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lazy_1 = require("./lazy");
var wait = function (loader, delay) { return new Promise(function (resolve) {
    return setTimeout(function () { return resolve(loader()); }, delay);
}); };
var RIC = window.requestIdleCallback || (function (callback) { return setTimeout(callback, 300); });
var PRIC = function (loader) { return new Promise(function (resolve) { return RIC(function () { return resolve(loader()); }); }); };
var RAF = requestAnimationFrame;
var PRAF = function (value) { return new Promise(function (resolve) { return RAF(function () { return resolve(value); }); }); };
exports.delayed = function (params) {
    var delay = params.delay, draf = params.draf, idle = params.idle;
    if (delay) {
        var loader_1 = params.loader;
        params.loader = function () { return wait(loader_1, delay); };
    }
    if (idle) {
        var loader_2 = params.loader;
        params.loader = function () { return PRIC(loader_2); };
    }
    if (draf) {
        var loader_3 = params.loader;
        params.loader = function () { return loader_3().then(PRAF).then(PRAF); };
    }
    return lazy_1.lazy(params);
};
//# sourceMappingURL=delayed.js.map