"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var context_1 = require("../context");
var util_1 = require("../util");
var Route_1 = tslib_1.__importDefault(require("./Route"));
var createMatcher_1 = tslib_1.__importDefault(require("./createMatcher"));
var Switch = function (props) {
    return util_1.h(context_1.Consumer, { name: util_1.ns("route/" + props.ns) }, function (_a) {
        var route = _a.route;
        var routes = react_1.Children.toArray(props.children);
        for (var i = 0; i < routes.length; i++) {
            if (process.env.NODE_ENV !== 'production') {
                if ((typeof routes[i] !== 'object') || (routes[i].type !== Route_1.default)) {
                    throw new TypeError('All <Switch> children must be <Route> elements.');
                }
            }
            var _b = routes[i].props, match = _b.match, exact = _b.exact;
            var matchResult = createMatcher_1.default(match, exact)(route);
            if (matchResult) {
                return routes[i];
            }
        }
        return null;
    });
};
exports.default = Switch;
//# sourceMappingURL=Switch.js.map