"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var compose = function () {
    var functions = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        functions[_i] = arguments[_i];
    }
    if (!functions.length) {
        return function (arg) { return arg; };
    }
    if (functions.length === 1) {
        return functions[0];
    }
    return function () {
        var args2 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args2[_i] = arguments[_i];
        }
        var result = functions[functions.length - 1].apply(functions, args2);
        for (var i = functions.length - 2; i >= 0; i--) {
            result = functions[i](result);
        }
        return result;
    };
};
exports.default = compose;
//# sourceMappingURL=compose.js.map