import { Component } from 'react';
export class AfterTimeout extends Component {
    constructor() {
        super(...arguments);
        this.state = {
            ready: false
        };
    }
    componentDidMount() {
        this.timer = setTimeout(() => {
            this.setState({
                ready: true
            });
        }, this.props.ms);
    }
    componentWillUnmount() {
        clearTimeout(this.timer);
    }
    render() {
        return this.state.ready ? this.props.children : null;
    }
}
AfterTimeout.defaultProps = {
    ms: 200
};
