import * as React from 'react';
const h = React.createElement;
const defaultRenderRow = cells => h('tr', null, ...cells);
export const ListTable = ({ cols, renderRow, children, ...rest }) => {
    const list = React.Children.toArray(children);
    const rows = [];
    const length = list.length;
    const rowLength = Math.ceil(length / cols);
    let i = 0;
    for (let m = 0; m < rowLength; m++) {
        const cells = [];
        for (let n = 0; n < cols; n++) {
            cells.push(h('td', null, i < length ? list[i] : null));
            i++;
        }
        rows.push(renderRow(cells));
    }
    return h('table', rest, h('tbody', null, ...rows));
};
ListTable.defaultProps = {
    cols: 3,
    renderRow: defaultRenderRow,
};
