import * as React from "react";
import renderProp from "../util/renderProp";
let DocumentTouch;
export const touchSupported = () => {
    const prefixes = " -webkit- -moz- -o- -ms- ".split(" ");
    const query = ["(", prefixes.join("touch-enabled),("), "heartz", ")"].join("");
    if ("ontouchstart" in window ||
        (window.DocumentTouch && document instanceof DocumentTouch)) {
        return true;
    }
    return window.matchMedia(query).matches;
};
export class TouchSupportSensor extends React.Component {
    constructor(props, context) {
        super(props, context);
        if (props.onlyMouse && props.onlyTouch) {
            console.warn("You're using both `onlyMouse` and `onlyTouch` on the TouchSupportSensor component. This is unsupported and may lead to unexpected results.");
        }
        this.state = { touchSupported: touchSupported() };
    }
    render() {
        if (this.props.onlyMouse && this.state.touchSupported) {
            return null;
        }
        if (this.props.onlyTouch && !this.state.touchSupported) {
            return null;
        }
        return renderProp(this.props, this.state);
    }
}
