export { View } from '../View';
export const WidthQuery = ({ width, children }) => {
    if (process.env.NODE_ENV !== 'production') {
        if (!Array.isArray(children)) {
            throw new TypeError('<WidthQuery/> expects multiple <View/> children.');
        }
    }
    for (const child of children) {
        const { maxWidth = Infinity, minWidth = 0 } = child.props;
        if (maxWidth > width && minWidth <= width) {
            return child;
        }
        if (maxWidth === Infinity && width === Infinity) {
            return child;
        }
    }
    return null;
};
