import { Component } from 'react';
import { SizeSensor } from '../SizeSensor';
import { noop, h } from '../util';
import faccToHoc, { divWrapper } from '../util/faccToHoc';
export class WidthSensor extends Component {
    constructor() {
        super(...arguments);
        this.state = {
            width: Infinity,
            height: Infinity,
        };
        this.onSize = (size) => {
            if (this.state.width !== size.width) {
                this.setState(size);
                this.props.onWidth(size);
            }
        };
    }
    render() {
        const { onWidth, ..._rest } = this.props;
        const rest = _rest;
        rest.onSize = this.onSize;
        return h(SizeSensor, rest);
    }
}
WidthSensor.defaultProps = {
    onWidth: noop
};
export const withWidth = faccToHoc(WidthSensor, 'width', divWrapper);
