import { Provider } from '../context';
import { h, ns } from '../util';
const Router = (props) => {
    const { ns: namespace, route, fullRoute, parent, children } = props;
    if (process.env.NODE_ENV !== 'production') {
        if (typeof route !== 'string') {
            throw new TypeError('Router route must be a string.');
        }
    }
    return h(Provider, {
        name: ns(`route/${namespace}`),
        value: {
            fullRoute: fullRoute || route,
            route,
            parent,
        }
    }, children);
};
export default Router;
