import { createElement as h } from 'react';
import { storiesOf } from '@storybook/react';
import { delayed } from './delayed';
import { viewport } from './viewport';
import ShowDocs from './ShowDocs';
const Loaded = () => h("div", null, "LOADED");
const Loadable = delayed({
    loading: h("div", null, "Loading...."),
    loader: () => Promise.resolve(Loaded),
    delay: 1000
});
const MyComp = viewport(Loadable);
const Demo1 = () => h("div", null,
    h("div", { style: { width: 800, height: 1200, border: '1px solid tomato' } }),
    h(MyComp, null));
const Demo2 = () => h("div", null,
    h(MyComp, null));
storiesOf('Dummies/viewport()', module)
    .add('Documentation', () => h(ShowDocs, { name: 'viewport' }))
    .add('Example', () => h(Demo1))
    .add('Shows when visible', () => h(Demo2));
